    	; GP32 Startup Boot Code
	AREA GP32BootStart, CODE, READONLY

	IMPORT |Image$$RO$$Base| 	; Base of RAM to initialize
	IMPORT |Image$$RO$$Limit| 	; End of ROM code (=start of ROM data)
	IMPORT |Image$$RW$$Base| 	; Base of RAM to initialize
	IMPORT |Image$$RW$$Limit| 	; End of ROM code (=start of ROM data)
	IMPORT |Image$$ZI$$Base| 	; Base and limit of area
	IMPORT |Image$$ZI$$Limit| 	; to zero initialize	
	IMPORT C_Entry		
	EXPORT MemCopy16	


Cpu_Mode_USR	EQU 	0x10
Cpu_Mode_IRQ 	EQU 	0x12
Cpu_Mode_SVC 	EQU 	0x13

Cpu_Stack_USR	EQU	0x0C700000	; USR stack address (FIXME!)
RAM_0C108134	EQU	0x0C108134
START_SP_AT_DBG	EQU	0x0c700000


	; HEADER
	ENTRY
	B		_GpInit	
	DCD		GP32BootStart  ;|Image$$R0$$Base|	; ?
	;DCD		|Image$$RO$$Limit|	; End of ROM code (=start of ROM data)
	;DCD		0x0C100000     ;|Image$$RW$$Base|	; Base of RAM to initialize
	;DCD		0x0C108140     ;|Image$$RW$$Limit|	; ?
	;DCD		0x0C100004     ;|Image$$ZI$$Base|	; Base and limit of area
	;DCD		0x0C108140     ;|Image$$ZI$$Limit|	; to zero initialize
	;DCD		|Image$$RO$$Base|	; ?                                   
      DCD		|Image$$RO$$Limit|	; End of ROM code (=start of ROM data)
	DCD		|Image$$RW$$Base|	; Base of RAM to initialize           
      DCD		|Image$$RW$$Limit|	; ?                                   
      DCD		|Image$$ZI$$Base|	; Base and limit of area              
	DCD		|Image$$ZI$$Limit|	;
	DCD		0x44450011	
	DCD		0x01234567	
	DCD		0x12345678	
	DCD		0x23456789	
	DCD		0x34567890	
	DCD		0x45678901	
	DCD		0x56789012	
	DCD		0x23456789	
	DCD		0x34567890	
	DCD		0x45678901	
	DCD		0x56789012	
	DCD		0x23456789	
	DCD		0x34567890	
	DCD		0x45678901	
	DCD		0x56789012	

_GpInit	
	bl      C_Entry


endGP32
      b endGP32

; void MemCopy16(void *src, void *dst, int count);
; R0 - Destination Address
; R1 - Source Address
; R2 - Number of half bytes to copy

MemCopy16
	STMFD SP!,{R0-R3}
MemCopyLoop
	LDRH R3,[R1],#2
	STRH R3,[R0],#2
	SUBS R2,R2,#1
	BNE MemCopyLoop
	LDMFD SP!,{R0-R3}
	MOV PC,LR   

 	END

